include(macro.m4)dnl

; as86 Macro Library
; (c) Franois-Ren "Far" Rideau Dang-Vu Bn 1989,1995

; see info file .../doc/info/m4macros.nfo (section * as86.m4::)
dnl
dnl
dnl
;;;;; Assembly control information
define({use16},
    {{use16}
     define({i386usemode},{})
     define({i386usemoderegext},{})})dnl
define({use32},
    {{use32}
     define({i386usemode},{d})
     define({i386usemoderegext},{e})})dnl
define({regext},
    {i386usemoderegext{}$*})dnl
dnl
;;;;; Instruction set enhancement macros
dnl
define({isreg},
	{ifelse( regexp({downcase($1)},
			{^[e]?\([a-d][hlx]\|si\|di\|bp\|sp\)$}),
		0,1,0)})dnl
dnl
define({clr},{ifelse(isreg($1),{true},{xor $1,$1},{mov $1,#0})})dnl
define({setf},{ifelse(isreg($1),{true},{or $1,$1},{test $1,#-1})})dnl
define({flushinstr},{local(fi,{__nl__ jmp fi __nl__ fi: __nl__})})dnl
define({pushax},{pusha}{i386usemode})dnl
define({popax},{popa}{i386usemode})dnl
define({pushfx},{pushf}{i386usemode})dnl
define({popfx},{popf}{i386usemode})dnl
define({pushm},
   {rept({param},{$@},
	 {ifelse(regexp({param},{^[af][dx]?$}),0,{push}{param}{__nl__},
		 {push param}{__nl__})})})dnl
define({popm},{_popm(reverse($@))})dnl
define({_popm},
   {rept({param},{$@},
	 {ifelse(regexp({param},{^[af][dx]?$}),0,{pop}{param}{__nl__},
		 {pop param}{__nl__})})})dnl
dnl
;;;;; Memory allocation
define({newheap},
	{ifelse($#,1,{define({heap_$1},0)}{define({heapprefix_$1},{})},
		$#,2,{define({heap_$1},{$2})}{define({heapprefix_$1},{})},
		{define({heap_$1},{$3})}{define({heapprefix_$1},{$2+})})})dnl
define({allot},{heapprefix_$1{}varadd({heap_$1},$2)})dnl
define({_alignoffset},
	{ifelse($#,0,0,
		$#,1,0,
		$#,2,{eval(($2-1)-(($1+$2-1)%($2)))},
		{eval(($2-1)-(($1-$3+$2-1)%($2)))})})dnl
define({_aligned},{eval(_alignoffset($@)+$1)})dnl
define({alignheap},{ifelse(allot({$1},_alignoffset(heap_$@)))})dnl
define({alallot},
	{ifelse($#,0,,$#,1,,
		$#,2,{alignheap({$1},{$2}){}allot({$1},{$2})},
		{alignheap({$1},{$2}){}allot({$1},{$3})})})dnl
dnl
;;;;; useful constants
; ASCII codes
LF	=	0x0A
CR	=	0x0D
define({CRLF},{CR,LF})dnl
Escape	=	0x1B
; Keyboard scancodes
K_Home	=	0x47
K_Up	=	0x48
K_PgUp	=	0x49
K_Lft	=	0x4B
K_Rgt	=	0x4D
K_EndC	=	0x4F
K_Dn	=	0x50
K_PgDn	=	0x51
K_InsC	=	0x52
K_Del	=	0x53
dnl
dnl
;;;;;;;;;; Structured programming ;;;;;;;;;;
__newstk__({struct})dnl
;;;;; negating code condition
define({ncc},
	{ifelse({$1},{po},{pe},
		{$1},{pe},{po},
		regexp({$1},{^n\(.*\)},{T}),{T},
		     {regexp({$1},{^n\(.*\)},{\1})},
		{n}{$1})})dnl
define({jn},
	{j{}ncc($1) shift($@)})dnl
dnl
;;;;; __IF__ ... __THEN__ ... ( __ELSE__ ...) __ENDIF__
dnl
define({IFNUM},0)dnl
define({__EXIT__IF__},{ENDIF})dnl
define({__EXIT__ELSE__},{ENDIF})dnl
define({__EXIT__THEN__},{ENDIF})dnl
define({__IF__},
	{__push__({struct},{@IF:varincr({IFNUM}):{$1}})})dnl
define({__THEN__},
  {ifelse(
    regexp(__pick__({struct}),{@IF:\(.*\):\(.*\)},
		{1{}pushdef({ifnum},{\1})pushdef({cc},{\2})}),
    1,
    {__pop__({struct})
     jn(cc) {ELSE}ifnum
     __push__({struct},{@THEN:}ifnum:)popdef({ifnum})popdef({cc})},
     {errprint({__THEN__ does not match __IF__},
		__pick__({struct}),__nl__)})})dnl
define({__ELSE__},
  {ifelse(
    regexp(__pick__({struct}),{@THEN:\(\w\):},{1{}pushdef({ifnum},{\1})}),
    1,
    {__pop__({struct})
     jmp {ENDIF}ifnum
     {ELSE}ifnum:
     __push__({struct},{@ELSE:}ifnum:)popdef({ifnum})},
    {errprint({__ELSE__ DOES NOT MATCH __THEN__},
		__pick__({struct}),__nl__)})})dnl
dnl
define({__ENDIF__},
  {ifelse(
     regexp(__pick__({struct}),
            {@THEN:\(.*\):},
	    {1{}pushdef({ifnum},{\1})}),
     1,
     {__pop__({struct})
      {ELSE}ifnum:
      {ENDIF}ifnum:
      popdef({ifnum})},
     regexp(__pick__({struct}),
            {@ELSE:\(\w\):},
            {1{}pushdef({ifnum},{\1})}),
     1,
     {__pop__({struct})dnl
      {ENDIF}ifnum:
      popdef({ifnum})},
     {errprint({__ENDIF__ does not match __THEN__ or __ELSE__},
		__pick__({struct}),__nl__)}
)})dnl
dnl
;;;;; __REPEAT__ ... __UNTIL__
dnl
define({REPEATNUM},0)dnl
define({__EXIT__REPEAT__},{UNTIL})dnl
define({__REPEAT__},
	{__push__({struct},{@REPEAT:}REPEATNUM:)
		{REPEAT}REPEATNUM:
		incrvar({REPEATNUM})
	})dnl
define({__UNTIL__},
  {ifelse(
     regexp(__pick__({struct}),
            {@REPEAT:\(.*\):},
	    {1{}pushdef({repeatnum},{\1})}),
     1,
     {__pop__({struct})
	jn({$1}) {REPEAT}repeatnum
	{UNTIL}repeatnum:
      popdef({repeatnum})},
     {errprint({__UNTIL__ does not match __REPEAT__},
		__pick__({struct}),__nl__)}
)})dnl
dnl
;;;;; __WHILE__ ... __DO__ ... __WEND__
dnl
define({WHILENUM},0)dnl
define({__EXIT__WHILE__},{WEND})dnl
define({__EXIT__DO__},{WEND})dnl
define({__WHILE__},
	{__push__({struct},{@WHILE}:WHILENUM:{$1})
		{WHILE}WHILENUM:
		incrvar({WHILENUM})
	})dnl
define({__DO__},
  {ifelse(
    regexp(__pick__({struct}),{@WHILE:\(.*\):\(.*\)},
		{1{}pushdef({whilenum},{\1})pushdef({cc},{\2})}),
    1,
    {__pop__({struct})
     jn(cc) {WEND}whilenum
     __push__({struct},{@DO}:whilenum:)popdef({whilenum})popdef({cc})},
     {errprint({__DO__ does not match __WHILE__},
		__pick__({struct}),__nl__)})})dnl
define({__WEND__},
  {ifelse(
     regexp(__pick__({struct}),
	    {@DO:\(.*\):},
	    {1{}pushdef({whilenum},{\1})}),
     1,
     {__pop__({struct})
      jmp {WHILE}whilenum
      {WEND}whilenum:
      popdef({whilenum})},
     {errprint({__WEND__ does not match __DO__},
		__pick__({struct}),__nl__)}
)})dnl
dnl
;;;;; __EXIT__
define({__EXIT__},
  {ifelse(
     regexp(__pick__({struct},eval($1-1)),
	    {@\(.*\):\(.*\):.*},
	    {1{}pushdef({struc},{\1})pushdef({num},{\2})}),
     1,
     {j$2 indir({__EXIT__}struc{__}){}num
      popdef({struc})popdef({num})},
     {errprint({cannot __EXIT__ what ???},__pick__({struct}),__nl__)})})dnl
dnl
;;;;;;;;;; Writing Libraries as Include files ;;;;;;;;;
; This is object managing at source code level. Reduces the number of
; object files (one source for any model), allows inlining, etc.
;
; To Do: use the STRUCSTK for this
; use markers to see if a particular procedure was already defined
;
define({LibProc},
    {})dnl
define({UseLib},
    {})dnl
ifelse({
; defining a macro defining a proc
Macro LibProc ProcName,MacroParams,Locals
	local MacroName
	MacroName CATSTR <def_>,ProcName
	% Macro <MacroName> <MacroParams>
	% local <Locals>
	% ifdifi <distance>,<inline>
	%   proc TestCPU distance
	% endif
EndM  LibProc

Macro EndLib whattoend
	% ifdifi <distance>,<inline>
	%    RET
    	%  EndP  TestCPU
	% endif
	% EndM <whattoend>
EndM  EndLib
})
;;;;;;;;; Diversions ;;;;;;;;;
define({__textseg__},
    {divert(0)})dnl
define({__stringseg__},
    {divert(1)})dnl
define({__dataseg__},
    {divert(2)})dnl
define({__udataseg__},
    {divert(3)})dnl
define({__end__},
    {.text
     undivert(1)
     .data
     undivert(2)
     .bss
     undivert(3)
})dnl
;;;;;;;;; Data definition ;;;;;;;;;
define({defb},
  {ifelse(
    {$#},0,,
    {$#},1,{defbone({$1})},
    {defbone({$1})defb(shift($@))})})dnl
define({defbone},
  {ifelse(
     regexp({$1},{^\('\|"\).*\("\|'\)$},{1}),1,{.ascii $1{} __nl__ },
     {.byte {$1} __nl__ })})dnl
define({lsa},
{
pushdef({labelprefix},{S})dnl
pushdef({string},newlabel)dnl
__stringseg__
string:
defb(shift($@))
__textseg__
mov {$1},#string
popdef({labelprefix})dnl
popdef({string})})dnl
dnl
ifelse({
;;;;;;;;;;;;;;;;;;;;;;;; Exportation de donnees ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Macro	Export	Identifier , Type , Name
  Local StringAddress, EName
  % ifnb <Name>
      EName equ Name
  % else
      EName equ Identifier
  % endif
  Segment HeaderStrings
    StringAddress:
    %	db	!'<Name>!' , 0
  EndS
  Segment HeaderBinary
	dd	StringAddress, ID, Type
  EndS
EndM
})
;;;;;;;;;;; CONSOLE I/O ;;;;;;;;;;;
define({PUTC},
    {ifelse($#,0,,{mov al,{$1}})
     call Putc})dnl
define({GETC},
    {
     ifelse({$1},,,
	{ifelse({$2},,,{pushax})
	 PUTS({$1})
	 ifelse({$2},,,{popax})})
	call	cGetc})dnl
define({PUTS},
    {
     ifelse({$1},{CRLF},{call PrCRLF},
	{ifelse({$2},,,{lsa(regext(si),shift($@),0)})
	 call	Puts})})dnl
;; _Pr????_: msg1, [Addr: seg,] val, msg2
define({_PrByte_},
    {pushax
     ifelse({$2},{al},,{mov al,{$2}})
     ifelse({$1},,,
	{push regext(ax)
	 PUTS($1)
	 pop regext(ax)})
     call PutHexByte
     ifelse({$3},,,{PUTS($3)})
     popax})dnl
define({_PrWord_},
    {pushax
     ifelse({$2},{ax},,{mov ax,{$2}})
     ifelse({$1},,,
	{push regext(ax)
	 PUTS($1)
	 pop regext(ax)})
     call PutHexWord
     ifelse({$3},,,{PUTS($3)})
     popax})dnl
define({_PrAddr_},
    {pushax
     push {$3} ; ofs
     push {$2} ; seg
     ifelse({$1},,,{PUTS($1)})
     pop es
     pop regext(di)
     call PutAddr
     ifelse({$4},,,{PUTS($4)})
     popax})dnl
define({_PrDword_},
    {pushax
     ifelse({$1},,
        {ifelse({$2},{eax},,{mov eax,{$2}})},
	{push {$2}
	 PUTS($1)
	 pop eax})
     call PutHexDword
     ifelse({$3},,,{PUTS($3)})
     popax})dnl
; _Pr*Zone_: mes1,seg,addr,len,mes2
define({_PrZone_},
    {pushax
     ifelse({$2},{es},,{push es})
     ifelse({$1},,,{PUTS($1)})
     push {$3} ; ofs
     push {$2} ; seg
     ifelse({$1},,
	{ifelse({$2},{es},,
		{push {$2}
		 pop es})
	ifelse({$3},{regext(di)},,
		{mov regext(di),{$3}})
	ifelse({$4},{regext(cx)},,
		{mov regext(cx),{$4}})},
	{pushm({$2},{$3},{$4})
	 PUTS($1)
	 popm(es,regext(di),regext(cx))})
     call PutZone
     ifelse({$2},{es},,{pop es})
     ifelse({$4},,,{PUTS($4)})
     popax})dnl
define({_PrWZone_},
    {pushax
     ifelse({$2},{es},,{push es})
     ifelse({$1},,,{PUTS($1)})
     push {$3} ; ofs
     push {$2} ; seg
     ifelse({$1},,
	{ifelse({$2},{es},,
		{push {$2}
		 pop es})
	ifelse({$3},{regext(di)},,
		{mov regext(di),{$3}})
	ifelse({$4},{regext(cx)},,
		{mov regext(cx),{$4}})},
	{pushm({$2},{$3},{$4})
	 PUTS($1)
	 popm(es,regext(di),regext(cx))})
     call PutWZone
     ifelse({$2},{es},,{pop es})
     ifelse({$4},,,{PUTS($4)})
     popax})dnl
define({_PrDZone_},
    {pushax
     ifelse({$2},{es},,{push es})
     ifelse({$1},,,{PUTS($1)})
     push {$3} ; ofs
     push {$2} ; seg
     ifelse({$1},,
	{ifelse({$2},{es},,
		{push {$2}
		 pop es})
	ifelse({$3},{regext(di)},,
		{mov regext(di),{$3}})
	ifelse({$4},{regext(cx)},,
		{mov regext(cx),{$4}})},
	{pushm({$2},{$3},{$4})
	 PUTS($1)
	 popm(es,regext(di),regext(cx))})
     call PutDZone
     ifelse({$2},{es},,{pop es})
     ifelse({$4},,,{PUTS($4)})
     popax})dnl
;;;;;;;;;;; DEBUGGING AID ;;;;;;;;;;;
define({DEBUG},0)dnl
define({_OUT_},{errprint($@)})dnl
define({__OUT__},
    {ifelse(DEBUG,0,,{_OUT_($@)})}dnl
define({z__},
    {IF DEBUG})dnl
define({__z},
    {ENDIF})dnl
define({__},
    {z__
     pushax
     PUTS($@)
     popax
     __z})dnl
define({z_z},
    {z__
     ifelse({$1},,,
	{pushax
	 PUTS($1)
	 popax})
     call DumpRegs
     ifelse({$2},,,
	{pushax
	 GETC
	 popax})
     __z})dnl
define({z__z},
    {z__
     ifelse({$1},,,
	{pushax
	 PUTS($1)
	 popax})
     call DumpERegs
     ifelse({$2},,,
	{pushax
	 GETC
	 popax})
     __z})dnl
define({zbyz},
    {z__
     _PrByte_($@)
     __z})dnl
define({zwoz},
    {z__
     _PrWord_($@)
     __z})dnl
define({zdwoz},
    {z__
     _PrDWord_($@)
     __z})dnl
define({zaddrz},
    {z__
     _PrAddr_($@)
     __z})dnl
define({zZonez},
    {z__
     _PrZone_($@)
     __z})dnl
define({zWZonez},
    {z__
     _PrWZone_($@)
     __z})dnl
define({zDZonez},
    {z__
     _PrDZone_($@)
     __z})dnl
;;;;;;;;;;;;; Heavy debugging ;;;;;;;;;
define({STEP},
    {ifdef({__DEBUG__},
	{push {$1}
	 pop gs})})dnl
; STOP(seg,vidmembase,x,y,char,attr)
define({STOP},
    {ifdef({__DEBUG__},
	{ifelse({$1},{ds},,{seg {$1}})
	 movw [{$2}+2*{$3}+2*80*{$4}],#{$5}+256*{$6}})})dnl
define({SST},
    {ifdef({__DEBUG__},
	{GETC($@)})})dnl

;;;;;;;;;;;;;;;;; Procedure library ;;;;;;;;;;;;;;;;;;
define({proclib},{
  pushdef({__RET__},{ret})
  Lib_$1(shift($@))
  popdef({__RET__})
})dnl
define({farlib},{
  pushdef({__RET__},{retf})
  Lib_$1(shift($@))
  popdef({__RET__})
})dnl
define({inlinelib},{
  pushdef({__RET__},{})
  Lib_$1(shift($@))
  popdef({__RET__})
})dnl
define({macrofylib}),{
  pushdef({__RET__},{})
  Lib_$1(shift($@))
  popdef({__RET__})
})dnl
dnl
;;;;; detecting CPU type
define({Lib_TestCPU},{
  __dataseg__
    NDP_STATUS dw -1
  __codeseg__
  ;;;; Procedure taken from Robert L. Hummel's book on 80x86 programming
  ;
  ; AH
  ; 01	8088 or 8086
  ; 02	80286
  ; 03	80386
  ; 04	486
  ;
  ; AL
  ; 00	No FPU
  ; 01	8087
  ; 02	80287
  ; 03	80387
  ; 04	486DX or 487SX
  ;
  ; Note: 0400 <=> 486SX w/o FPU.
  ;;;;;;
  ; destroys all general purpose registers, including FP registers
	MOV	DX,0x100	; default answer
	MOV	[NDP_STATUS],-1 ; non zero
  ;; on 8088/8086, bits 12 to 15 of pushed Flags value are set,
  ;; that's why we'll try to clear them.
	PUSHF
	POP	AX
	AND	AH,0x0F		;(clear most significant bits)
	PUSH	AX
	POPF
	PUSHF
	POP	AX
	AND	AH,0xF0		;(get them back)
	CMP	AH,0xF0
	JZ	CPUID_2		;if all set, it's a 8086/8088
  ;; on the 80286, on the opposite, they are cleared
	INC	DH
	PUSHF
	POP	AX
	OR	AH,0xF0		;(set most significant bits)
	PUSH	AX
	POPF
	PUSHF
	POP	AX
	AND	AH,0xF0		;(get them back)
	JZ	CPUID_2		;if cleared, it's a 80286
  ;; sur the 80486, the EFLAGS registers has got an AC alignment bit
	INC	DH
	CLI
	MOV	BP,SP		; save SP
	AND	SP,NOT 3	; align SP
	PUSHFD
	POP	EAX
	MOV	EBX,EAX		; save EFLAGS
	XOR	EAX,0x00040000	; complement AC
	PUSH	EAX
	POPFD
	PUSHFD
	POP	EAX
	PUSH	EBX
	POPFD			; restore AC
	MOV	SP,BP		; restore SP
	XOR	EAX,EBX		; look if AC was modified
	STI
	JZ	CPUID_2		; no: it's a 386
	INC	DH
  ;;;; Now, test for coprocessor:
CPUID_2:
	FNINIT				;reset status word
	FNSTSW	[NDP_STATUS]
	CMP	[Byte ptr NDP_STATUS],0	;if non zero, no FPU
	JNZ	CPUID_3
	FNSTCW	[NDP_STATUS]		;try to write control word
	AND	[NDP_STATUS],0x103F
	CMP	[NDP_STATUS],0x3F
	JNZ	CPUID_3
  ;;;; The only case when the FPU doesn't answer is a 80386+80287
	MOV	DL,DH			;initialize FPU type
	CMP	DH,3			;no 386 => ok
	JNZ	CPUID_3
  ;;; 387/287: the initialized NDP must manage infinity,
  ;;; but they're the same to the 287	FLD1
	FLDZ
	FDIV
	FLD	ST
	FCHS
	FCOMPP
	FSTSW	[NDP_STATUS]
	MOV	AX,[NDP_STATUS]
	SAHF
	JNZ	CPUID_3			;different => 387
	DEC	DL
CPUID_3:
	MOV	AX,DX
	__RET__
})


ifelse({
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;; Module de gestion de la mmoire en mode protg. ;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; voir le fichier mem386.doc pour la documentation...

; [i] Macros en mode rel
; =======================

; Contrle de la ligne A20
; ------------------------

;;;; Constantes pour accder  la ligne A20
KB_command_port	= 64h		;(en criture)
KB_status_port	= 64h		;(en lecture)
KB_data_port	= 60h
IB_free		= 2		;pour savoir si le port clavier est libre
KB_command_A20	= 0D1h		;pour accder au port de la ligne A20
set_A20_ON  = 11011111b
set_A20_OFF = 11011101b

;;;; Macros pour contrler la ligne A20

Macro	def_proc_KB_Ready  distance,erreur,nombre_essai
  local wait_IB
  ifdifi <distance>,<inline>
    Proc KB_Ready distance
  endif
 ;; Tester si le port clavier est disponible (chose ncessaire
 ;; avant de lui envoyer des commandes)
 ;; - erreur doit tre une tiquette ou se brancher si la ligne
 ;; n'est pas disponible.
 ;; - nombre_essai contient le nombre d'essais d'accs au port avant de
 ;; s'avouer vaincu.
 ;; ** dtruit AX,CX
   ifnb <&nombre_essai>
     ifdifi <nombre_essai>,<cx>
       mov cx,nombre_essai
     endif
   else
     mov cx,100
   endif
  wait_IB:
   in al,KB_status_port
   test al,IB_free
   loopne wait_IB
   jcxz erreur
  ifdifi <distance>,<inline>
	RET
    EndP  KB_Ready
  endif
EndM   def_proc_KB_Ready

Macro  set_A20	ON_OFF
 ;;  Cette macro active ou dsactive la ligne A20, en ayant test que le port
 ;; clavier est disponible.
 ;; - ON_OFF contient ON ou OFF selon que l'on veuille activer ou dsactiver
 ;; la ligne. Si ce paramtre est absent, AH doit contenir A20_ON ou A20_OFF.
 ;; - erreur doit tre une tiquette o se brancher si la ligne
 ;; n'est pas disponible.
 ;; - nombre_essai contient le nombre d'essais d'accs au port avant de
 ;; s'avouer vaincu.
 ;; ** dtruit AX
  ifnb <&ON_OFF>
    mov ah,A20_&ON_OFF
  endif
  call KB_Ready
  mov al,KB_command_A20
  out KB_command_port,al
  ;call KB_Ready	; Linus does it
  mov al,ah
  out KB_command_port,al
  ;call KB_Ready	; Linus does it
EndM  set_A20

Macro	Test_A20
   local Exit_
   ;;  Teste si la ligne A20 est active, en vrifiant si oui ou non les
   ;; adresses mmoire s'enroulent aprs la limite du mga-octet.
   ;; * Renvoie C ssi la ligne est active
   ;; ** dtruit AX
   push ds
   push es
   cli
   sub ax,ax
   mov es,ax		; es=$0000
   dec ax
   mov ds,ax		; ds=$FFFF
   mov ax,ds:[-2]	;; vrifier [$10FFEE]=[$0FFEE]
   cmp ax,es:[-18]
   stc
   jnz Exit_
   inc ds:[-2]		;; vrifier [$10FFEE]=[$0FFEE] aprs modification
   cmp ax,es:[-18]
   mov ds:[-2],ax
   stc
   jz Exit_
   clc
  Exit_:
   sti
   pop es
   pop ds
EndM Test_A20

Macro Disable_NMI
	mov al,80h
	out 70h,al
	in al,71h
EndM  Disable_NMI

Macro Enable_NMI
	mov al,00h
	out 70h,al
	in al,71h
EndM  Enable_NMI



; Le standard XMS
; ---------------

Struc	XMS_Move_Params		;; paramtres pour la fonction XMS 0Bh
   LengthToMove	dd	?
   SourceHandle	dw	?
   SourceOffset	dd	?
   DestHandle	dw	?
   DestOffset	dd	?
EndS	XMS_Move_Params





; Gestion de la mmoire en mode protg
; =====================================

Macro	DefDescriptor	bas,Lim,_P_DPL_DT_Type,_G_D_0_AVL
    dw  (Lim) and 0FFFFh
    dw	(bas) and 0FFFFh
    db	( (bas) shr 16 ) and 0FFh
    db	_P_DPL_DT_Type
    db	(_G_D_0_AVL) shl 4 + ( ( (Lim) shr 16) and 0Fh )
    db	(bas) shr 24
EndM

Macro	DefPorte	sel,ofs,compteur,_P_DPL_DT_Type
    dw  (ofs) and 0FFFFh
    dw	sel
    db	compteur
    db	_P_DPL_DT_Type
    dw (ofs) shr 16
EndM

Macro	SetDescriptor	DESCRIPT
   ;;; Cette macro initialise un descripteur avec
   ;;; - DESCRIPT contenant la chane adresse du descripteur
   ;;; - ebx pour adresse de base
   ;;; - ecx pour champ limite
   ;;; - al pour les champs d'information: P,DPL,DT,Type
   ;;; - ah pour G,D,AVL
   ;;; * dtruit eax,ebx,ecx
   mov [DESCRIPT],cx
   shr ecx,16
   mov [DESCRIPT+2],bx
   shr ebx,16
   or cl,ah
   mov ch,bh
   mov bh,al
   mov [DESCRIPT+4],bx
   mov [DESCRIPT+6],cx
EndM

Macro	GetDescriptor	DESCRIPT
   Local
   ;;; Cette macro fait le contraire de la prcdente:
   ;;; - DESCRIPT contient la chane adresse du descripteur
   ;;; - ebx pour adresse de base
   ;;; - ecx pour champ limite
   ;;; - al pour les champs d'information: P,DPL,DT,Type
   ;;; - ah pour G,D,AVL
   mov cx,DESCRIPT[6]
   mov bx,DESCRIPT[4]
   mov al,bh
   mov bh,ch
   mov ah,cl
   and cx,0Fh
   shl ebx,16
   mov bx,DESCRIPT[2]
   shl ecx,16
   mov cx,DESCRIPT
EndM

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; TSS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Struc	pushad_s
	irp   parm,<edi,esi,ebp,esp,ebx,edx,ecx,eax>
          pushad_&parm  dd  ?
	endm
EndS	pushad_s
Struc	pusha_s
	irp   parm,<di,si,bp,sp,bx,dx,cx,ax>
          pusha_&parm  dw  ?
	endm
EndS	pusha_s

Struc	TSS16
;;;; spcifications Intel
    Sel_Lien_Arriere dw ?
    SP_CPL0	dw	? ; not updated by task switching
    SS_CPL0	dw	? ;
    SP_CPL1	dw	? ;
    SS_CPL1	dw	? ;
    SP_CPL2	dw	? ;
    SS_CPL2	dw	? ;
    saveIP	dw	?
    saveFlags	dw	?
    saveAX	dw	?
    saveCX	dw	?
    saveDX	dw	?
    saveBX	dw	?
    saveSP	dw	?
    saveBP	dw	?
    saveSI	dw	?
    saveDI	dw	?
    saveES	dw	?
    saveCS	dw	?
    saveSS	dw	?
    saveDS	dw	?
    saveLDT	dw	? ; not updated by task switching
EndS

Struc	TSS32
;;;; spcifications Intel
    Sel_Lien_Arriere dw ?,0	;(???)
    ESP_CPL0	dd	?	; not updated by task switching
    SS_CPL0	dw	?,0	;
    ESP_CPL1	dd	?	;
    SS_CPL1	dw	?,0	;
    ESP_CPL2	dd	?	;
    SS_CPL2	dw	?,0	;
		dd	0	;(reserved)
    saveEIP	dd	?
    saveEFlags	dd	?
    saveEAX	dd	?
    saveECX	dd	?
    saveEDX	dd	?
    saveEBX	dd	?
    saveESP	dd	?
    saveEBP	dd	?
    saveESI	dd	?
    saveEDI	dd	?
    saveES	dw	?,0	; 0's not updated by task switching
    saveCS	dw	?,0
    saveSS	dw	?,0
    saveDS	dw	?,0
    saveFS	dw	?,0
    saveGS	dw	?,0
    saveLDT	dw	?,0	; not updated by task switching
    TrapBit	dw	0	; not updated by task switching
    IO_Map_Base	dw	?	; not updated by task switching
EndS

PAGESIZE = 4096
PAGEBITS = 12
})dnl
